#include <iostream>
#include <sstream>
#include <json/json.h>

#include <QtCore/QDebug>
#include <QtCore/QJsonDocument>
#include <QtCore/QJsonObject>

#if 1 // Switch to 0 to check non-empty behavior
static const std::string JSON = "";
#else
static const std::string JSON = "{ \"bool\" : false }";
#endif
static const QByteArray QJSON = QByteArray::fromStdString(JSON);

void checkQJson() {
    QJsonDocument doc = QJsonDocument::fromJson(QJSON);
    QJsonObject obj = doc.object();
    bool field = obj["bool"].toBool();
    std::cout << "[QtJson ] bool field: " << field << std::endl;
}

void checkJsoncpp() {
    Json::Value val;
    try {
        std::istringstream(JSON) >> val;
    } catch (Json::RuntimeError &e) {
        std::cerr << "Failed to parse: " << e.what() << std::endl;
    }
    bool field = val["bool"].asBool();
    std::cout << "[Jsoncpp] bool field: " << field << std::endl;
}

void solution() {
    Json::Value val;
    if (!JSON.empty()) {
        try {
            std::istringstream(JSON) >> val;
        } catch (Json::RuntimeError &e) {
            std::cerr << "Failed to parse: " << e.what() << std::endl;
        }
    }
    bool field = val["bool"].asBool();
    std::cout << "[Jsoncpp] bool field*: " << field << std::endl;
}

int main(int argc, char *argv[])
{
    checkQJson();
    checkJsoncpp();
    solution();
    return 0;
}
