#include <iostream>
#include <sstream>
#include <json/json.h>

#include <QtCore/QDebug>
#include <QtCore/QJsonDocument>
#include <QtCore/QJsonObject>

static const std::string JSON = "{}";
static const QByteArray QJSON = QByteArray::fromStdString(JSON);

void checkQJson() {
    QJsonDocument doc = QJsonDocument::fromJson(QJSON);
    QJsonObject obj = doc.object();
    QByteArray field = QJsonDocument(obj["windowGroup"].toObject()).toJson();
    std::cout << "[QtJson ] windowGroup: " << field.toStdString() << std::endl;
}

void checkJsoncpp() {
    Json::Value val;
    std::istringstream(JSON) >> val;
    std::string field = val["windowGroup"].toStyledString();
    std::cout << "[Jsoncpp] windowGroup: " << field << std::endl;
}

void solution() {
    Json::Value val;
    std::istringstream(JSON) >> val;
    std::string field = val.get("windowGroup", Json::Value(Json::objectValue)).toStyledString();
    std::cout << "[Jsoncpp] windowGroup: " << field << std::endl;
}

int main(int argc, char *argv[])
{
    checkQJson();
    checkJsoncpp();
    solution();
    return 0;
}
